]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- unify sourceforge URL-s
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
cd445739
AM
1#!/bin/sh
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
7304d35c 25V 0.13 (C) 1999-2005 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
40UPDATE=""
41UPDATE5=""
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
64BCOND=""
65GROUP_BCONDS="no"
947025e5 66CVSIGNORE_DF="no"
d287305c 67
68PATCHES=""
69SOURCES=""
cd445739 70ICONS=""
d287305c 71PACKAGE_RELEASE=""
72PACKAGE_VERSION=""
73PACKAGE_NAME=""
cd445739
AM
74PROTOCOL="ftp"
75WGET_RETRIES=${MAX_WGET_RETRIES:-0}
76CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
77
78CVSTAG=""
79RES_FILE=""
80
81CVS_SERVER="cvs.pld-linux.org"
82DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 83ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 84
36d03934 85DEF_NICE_LEVEL=19
cd445739
AM
86
87FAIL_IF_NO_SOURCES="yes"
88
ab4a2b6e
ER
89if [ -x /usr/bin/rpm-getdeps ]; then
90 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
91else
92 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
93fi
94
cd445739
AM
95# Here we load saved user environment used to
96# predefine options set above, or passed to builder
97# in command line.
98# This one reads global system environment settings:
99if [ -f ~/etc/builderrc ]; then
100 . ~/etc/builderrc
101fi
102# And this one cascades settings using user personal
103# builder settings.
104# Example of ~/.builderrc:
105#
106#UPDATE_POLDEK_INDEXES="yes"
107#FETCH_BUILD_REQUIRES="yes"
108#REMOVE_BUILD_REQUIRES="force"
109#GROUP_BCONDS="yes"
110#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
111#
a83e5405 112SU_SUDO=""
cd445739
AM
113if [ -n "$HOME_ETC" ]; then
114 USER_CFG="$HOME_ETC/.builderrc"
115else
116 USER_CFG=~/.builderrc
117fi
118
119[ -f "$USER_CFG" ] && . "$USER_CFG"
120
06f3864d
AM
121wget --help 2>&1 | grep -q ' \-\-no-check\-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
122
ca2e6c31 123if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
124 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
125 GETURI2="$GETURI"
126 OUTFILEOPT="-O"
ca2e6c31 127elif [ -n "$USE_AXEL" ]; then
cede92b3 128 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
129 GETURI2="$GETURI"
130 OUTFILEOPT="-o"
ca2e6c31 131else
7e365483
KK
132 wget --help 2>&1 | grep -q ' \-\-inet ' && WGET_OPTS="$WGET_OPTS --inet"
133 wget --help 2>&1 | grep -q ' \-\-retry\-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 134
7e365483
KK
135 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
136 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
137 OUTFILEOPT="-O"
2bc5451f 138fi
11468b23 139
11468b23
AM
140GETLOCAL="cp -a"
141
142if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
143 RPM="rpm"
144 RPMBUILD="rpm"
145else
146 RPM="rpm"
147 RPMBUILD="rpmbuild"
148fi
149
150POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 151POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 152
cd445739
AM
153run_poldek()
154{
155 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
156 if [ -n "$LOGFILE" ]; then
157 LOG=`eval echo $LOGFILE`
158 if [ -n "$LASTLOG_FILE" ]; then
159 echo "LASTLOG=$LOG" > $LASTLOG_FILE
160 fi
040282bb 161 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
162 return $exit_pldk
163 else
164 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
165 return `cat ${RES_FILE}`
166 rm -rf ${RES_FILE}
167 fi
168}
169
cd445739
AM
170#---------------------------------------------
171# functions
da946cd6 172
5a491465 173usage()
174{
cd445739
AM
175 if [ -n "$DEBUG" ]; then set -xv; fi
176 echo "\
177Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
81f85806 178
cd445739
AM
179[-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
180[{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>] [-g|--get]
181[-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
182[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
183[-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
184[-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
185[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
dfe2cb9a 186[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--show-bconds]
cd445739 187[--with/--without <feature>] [--define <macro> <value>] <package>[.spec]
2a5f078d 188
cd445739
AM
189-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
190-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
191-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
192-D, --debug - enable builder script debugging mode,
193-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
194-V, --version - output builder version
195-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
196-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
197 from <package>.spec,
198-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
199 only package from <package>.spec,
c56807e0
ER
200-bp, --build-prep - execute the %prep phase of <package>.spec,
201-bc - reserved (not implemented)
202-bi reserved (not implemented)
cd445739
AM
203-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
204 them into src.rpm,
c56807e0 205--short-circuit - reserved (not implemented)
cd445739
AM
206-B, --branch - add branch
207-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
208 SPECS and \$RPM_BUILD_ROOT),
2a5f078d 209-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
210 - setup \$CVSROOT,
211--define <macro> <value>
212 - define a macro <macro> with value <value>,
213--nodeps - rpm won't check any dependences
214-g, --get - get <package>.spec and all related files from CVS repo
215 or HTTP/FTP,
216-h, --help - this message,
217--http - use http instead of ftp,
218-l <logfile>, --logtofile <logfile>
219 - log all to file,
220-m, --mr-proper - only remove all files related to spec file and all work
221 resources,
222-nc, --no-cvs - don't download sources from CVS, if source URL is given,
223-ncs, --no-cvs-specs
224 - don't check specs in CVS
225-nd, --no-distfiles - don't download from distfiles
226-nm, --no-mirrors - don't download from mirror, if source URL is given,
227-nu, --no-urls - don't try to download from FTP/HTTP location,
228-ns, --no-srcs - don't download Sources
229-ns0, --no-source0 - don't download Source0
230-nn, --no-net - don't download anything from the net
231--opts <rpm opts> - additional options for rpm
232-q, --quiet - be quiet,
233--date yyyy-mm-dd - build package using resources from specified CVS date,
234-r <cvstag>, --cvstag <cvstag>
235 - build package using resources from specified CVS tag,
236-R, --fetch-build-requires
237 - fetch what is BuildRequired,
238-RB, --remove-build-requires
239 - remove all you fetched with -R or --fetch-build-requires
240 remember, this option requires confirmation,
241-FRB, --force-remove-build-requires
242 - remove all you fetched with -R or --fetch-build-requires
243 remember, this option works without confirmation,
a7eefc54 244-sf, --source-files - list sources - bare filenames (intended for offline
245 operations; does not work when Icon field is present
246 but icon file is absent),
247-sp, --source-paths - list sources - filenames with full local paths (intended for
248 offline operations; does not work when Icon field is present
249 but icon file is absent),
cd445739
AM
250-T <cvstag> , --tag <cvstag>
251 - add cvs tag <cvstag> for files,
252-Tvs, --tag-version-stable
094bd95b 253 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 254-Tvn, --tag-version-nest
1691a37b 255 - add cvs tags NEST and NAME-VERSION-RELEASE for files,
cd445739
AM
256-Ts, --tag-stable
257 - add cvs tag STABLE for files,
258-Tn, --tag-nest
259 - add cvs tag NEST for files,
260-Tv, --tag-version
1691a37b 261 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
262-Tp, --tag-prefix <prefix>
263 - add <prefix> to NAME-VERSION-RELEASE tags,
264-tt, --test-tag <prefix>
265 - fail if tag is already present,
50321881
JK
266-ir, --integer-release-only
267 - allow only integer and snapshot releases
cd445739
AM
268-v, --verbose - be verbose,
269-u, --try-upgrade - check version, and try to upgrade package
270-un, --try-upgrade-with-float-version
271 - as above, but allow float version
deccc50e 272-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
273-Upi, --update-poldek-indexes
274 - refresh or make poldek package index files.
c890b916 275-np, --nopatch <patchnumber>
bed98670 276 - don't apply <patchnumber>
dfe2cb9a
MK
277--show-bconds - show available conditional builds, which can be used
278 - with --with and/or --without switches.
cd445739
AM
279--with/--without <feature>
280 - conditional build package depending on %_with_<feature>/
281 %_without_<feature> macro switch. You may now use
282 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
283 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 284--target <platform>, --target=<platform>
64ea5308 285 - build for platform <platform>.
5a491465 286"
287}
288
c890b916 289update_shell_title() {
a0d6396b 290 [ -t 1 ] || return
2e5be021 291 local msg="builder[$SPECFILE] $*"
c890b916
ER
292 case "$TERM" in
293 cygwin|xterm*)
2e5be021 294 echo -ne "\033]1;$msg\007\033]2;$msg\007"
c890b916
ER
295 ;;
296 screen*)
2e5be021 297 echo -ne "\033]0;$msg\007"
c890b916
ER
298 ;;
299 esac
300}
301
7e40520f
ER
302# set TARGET from BuildArch: from SPECFILE
303set_spec_target() {
304 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
305 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
306 if [ "$tmp" ]; then
307 TARGET="$tmp"
308 case "$RPMBUILD" in
309 "rpmbuild")
310 TARGET_SWITCH="--target $TARGET" ;;
311 "rpm")
312 TARGET_SWITCH="--target=$TARGET" ;;
313 esac
314 fi
315 fi
316}
317
cd445739 318cache_rpm_dump () {
b2aeec7d
AM
319 if [ -n "$DEBUG" ]; then
320 set -x;
321 set -v;
322 fi
7e40520f 323
cd445739
AM
324rpm_dump_cache=`
325 case "$RPMBUILD" in
326 rpm )
2a5f078d 327 rpm -bp --nodeps --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
328 ;;
329 rpmbuild )
2f810e46 330 rpmbuild --nodigest --nosignature --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
331 ;;
332 esac`
333}
334
335rpm_dump () {
336 if [ -z "$rpm_dump_cache" ] ; then
337 echo "internal error: cache_rpm_dump not called!" 1>&2
338 fi
339 echo "$rpm_dump_cache"
340}
341
59398507 342parse_spec()
343{
2e5be021 344 update_shell_title "parse_spec"
cd445739
AM
345 if [ -n "$DEBUG" ]; then
346 set -x;
347 set -v;
348 fi
b2975fc3 349
cd445739 350 cd $SPECS_DIR
4ca52257 351
cd445739 352 cache_rpm_dump
00fcec7e 353
cd445739
AM
354 if [ "$NOSRCS" != "yes" ]; then
355 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
356 fi
357 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
358 FAIL_IF_NO_SOURCES="no"
359 fi
360
361 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
362 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
363 PACKAGE_NAME="`$RPM -q --qf '%{NAME}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
364 PACKAGE_VERSION="`$RPM -q --qf '%{VERSION}\n' --specfile ${SPECFILE} 2> /dev/null| head -n 1`"
365 PACKAGE_RELEASE="`$RPM -q --qf '%{RELEASE}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
366
341603cf 367# These variables may be unset after first cache_rpm_dump call
368# (because of not-yet-retrieved icon file)
369#
370# if [ -z "$PACKAGE_NAME" -o -z "$PACKAGE_VERSION" -o -z "$PACKAGE_RELEASE" ]; then
371# Exit_error err_no_package_data;
372# fi
78eab2a1 373
cd445739
AM
374 if [ -n "$BE_VERBOSE" ]; then
375 echo "- Sources : `nourl $SOURCES`"
376 if [ -n "$PATCHES" ]; then
377 echo "- Patches : `nourl $PATCHES`"
378 else
379 echo "- Patches : *no patches needed*"
380 fi
381 if [ -n "$ICONS" ]; then
382 echo "- Icon : `nourl $ICONS`"
383 else
384 echo "- Icon : *no package icon*"
385 fi
386 echo "- Name : $PACKAGE_NAME"
387 echo "- Version : $PACKAGE_VERSION"
388 echo "- Release : $PACKAGE_RELEASE"
389 fi
390}
391
392Exit_error()
393{
394 if [ -n "$DEBUG" ]; then
395 set -x;
396 set -v;
397 fi
398
399 cd "$__PWD"
400
401 case "$1" in
402 "err_no_spec_in_cmdl" )
403 remove_build_requires
404 echo "ERROR: spec file name not specified.";
405 exit 2 ;;
406 "err_no_spec_in_repo" )
407 remove_build_requires
408 echo "Error: spec file not stored in CVS repo.";
409 exit 3 ;;
410 "err_no_source_in_repo" )
411 remove_build_requires
412 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)";
413 exit 4 ;;
414 "err_build_fail" )
415 remove_build_requires
416 echo "Error: package build failed. (${2:-no more info})";
417 exit 5 ;;
78eab2a1
AM
418 "err_no_package_data" )
419 remove_build_requires
420 echo "Error: couldn't get out package name/version/release from spec file."
421 exit 6 ;;
50321881
JK
422 "err_tag_exists" )
423 remove_build_requires
424 echo "Tag ${2} already exists (spec release: ${3}).";
425 exit 9 ;;
426 "err_fract_rel" )
427 remove_build_requires
428 echo "Release ${2} not integer and not a snapshot.";
429 exit 10 ;;
fb96e0b5
AM
430 "err_branch_exists" )
431 remove_build_requires
432 echo "Tree branch already exists (${2}).";
433 exit 11 ;;
50321881 434
cd445739 435 esac
50321881 436 echo "Unknown error."
2a5f078d 437 exit 100
cd445739
AM
438}
439
440init_builder()
441{
442 if [ -n "$DEBUG" ]; then
443 set -x;
444 set -v;
0dd6320d 445 fi
cd445739
AM
446
447 SOURCE_DIR="`$RPM --eval '%{_sourcedir}'`"
448 SPECS_DIR="`$RPM --eval '%{_specdir}'`"
449
450 __PWD="`pwd`"
00fcec7e 451}
452
d6a77ddb 453get_spec()
1471f6d6 454{
c890b916 455
2e5be021 456 update_shell_title "get_spec"
c890b916 457
cd445739
AM
458 if [ -n "$DEBUG" ]; then
459 set -x;
460 set -v;
461 fi
462
463 cd "$SPECS_DIR"
464 if [ \! -f "$SPECFILE" ]; then
465 SPECFILE="`basename $SPECFILE .spec`.spec";
466 fi
467 if [ "$NOCVSSPEC" != "yes" ]; then
468 OPTIONS="up "
469
470 if [ -n "$CVSROOT" ]; then
471 OPTIONS="-d $CVSROOT $OPTIONS"
472 else
473 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
474 echo "warning: No cvs access defined - using local .spec file"
475 NOCVSSPEC="yes"
476 fi
477 fi
478
479 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
480 OPTIONS="$OPTIONS -A"
481 else
482 if [ -n "$CVSDATE" ]; then
483 OPTIONS="$OPTIONS -D $CVSDATE"
484 fi
485 if [ -n "$CVSTAG" ]; then
486 OPTIONS="$OPTIONS -r $CVSTAG"
487 fi
488 fi
489
490 result=1
491 retries_counter=0
492 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]
493 do
494 retries_counter=$(( $retries_counter + 1 ))
495 output=$(LC_ALL=C cvs $OPTIONS $SPECFILE 2>&1)
496 result=$?
497 [ -n "$output" ] && echo "$output"
498 if [ "$result" -ne "0" ]; then
499 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$retries_counter" -le "$CVS_RETRIES" ]; then
500 echo "Trying again [$SPECFILE]... ($retries_counter)"
501 sleep 2
502 continue
503 fi
504 Exit_error err_no_spec_in_repo;
505 fi
506 done
507 fi
508 if [ ! -f "$SPECFILE" ]; then
509 Exit_error err_no_spec_in_repo;
510 fi
511
512 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
513 chmod $CHMOD_MODE $SPECFILE
514 fi
515 unset OPTIONS
a7eefc54 516 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f
ER
517
518 set_spec_target
cd445739
AM
519}
520
521find_mirror()
522{
523 cd "$SPECS_DIR"
524 url="$1"
525 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
526 cvs update mirrors >&2
527 fi
528
529 IFS="|"
530 while read origin mirror name rest
531 do
532 ol=`echo -n "$origin"|wc -c`
533 prefix="`echo -n "$url" | head -c $ol`"
534 if [ "$prefix" = "$origin" ] ; then
535 suffix="`echo "$url"|cut -b $ol-`"
536 echo -n "$mirror$suffix"
537 return 0
538 fi
539 done < mirrors
540 echo "$url"
541}
542
543src_no ()
544{
545 cd $SPECS_DIR
546 rpm_dump | \
547 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
548 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
549 head -n 1 | xargs
1471f6d6 550}
551
cd445739 552src_md5 ()
8ba5cdda 553{
cd445739
AM
554 [ X"$NO5" = X"yes" ] && return
555 no=$(src_no "$1")
556 [ -z "$no" ] && return
557 cd $SPECS_DIR
47a8df12 558 spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
cd445739
AM
559 if [ -z "$spec_rev" ]; then
560 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
561 fi
562 spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
563 md5=$(grep -s -v '^#' additional-md5sums | \
564 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
565 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
566 grep -E '^[0-9a-f]{32}$')
567 if [ X"$md5" = X"" ] ; then
6203ea52
AG
568 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
569 if [ ! -z "$source_md5" ] ; then
7e365483 570 echo $source_md5;
6203ea52 571 else
7e365483
KK
572 # we have empty SourceX-md5, but it is still possible
573 # that we have NoSourceX-md5 AND NoSource: X
574 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
575 if [ ! -z "$nosource_md5" -a ! X"`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" = X"" ] ; then
576 echo $nosource_md5;
577 fi;
6203ea52 578 fi;
cd445739
AM
579 else
580 if [ $(echo "$md5" | wc -l) != 1 ] ; then
581 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
582 fi
583 echo "$md5" | tail -n 1
584 fi
585}
586
587distfiles_url ()
588{
1246dc2a 589 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
590}
591
592distfiles_attic_url ()
593{
1246dc2a 594 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
595}
596
597good_md5 ()
598{
599 md5=$(src_md5 "$1")
600 [ "$md5" = "" ] || \
601 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
602}
603
a4b50627
AF
604good_size ()
605{
deccc50e
AM
606 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
607 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
608}
609
947025e5 610cvsignore_df ()
611{
612 if [ "$CVSIGNORE_DF" != "yes" ]; then
613 return
614 fi
615 cvsignore=${SOURCE_DIR}/.cvsignore
616 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
617 echo "$1" >> $cvsignore
618 fi
619}
620
cd445739
AM
621get_files()
622{
623 GET_FILES="$@"
28fac57a 624 update_shell_title "get_files"
cd445739
AM
625
626 if [ -n "$DEBUG" ]; then
627 set -x;
628 set -v;
629 fi
630
631 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
632 cd "$SOURCE_DIR"
633
634 OPTIONS="up "
635 if [ -n "$CVSROOT" ]; then
636 OPTIONS="-d $CVSROOT $OPTIONS"
637 else
638 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
639 echo "warning: No cvs access defined for SOURCES"
640 NOCVS="yes"
641 fi
642 fi
643 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
644 OPTIONS="$OPTIONS -A"
645 else
646 if [ -n "$CVSDATE" ]; then
647 OPTIONS="$OPTIONS -D $CVSDATE"
648 fi
649 if [ -n "$CVSTAG" ]; then
650 OPTIONS="$OPTIONS -r $CVSTAG"
651 fi
652 fi
653 for i in $GET_FILES
654 do
655 if [ -n "$UPDATE5" ]; then
656 if [ -n "$ADD5" ]; then
657 [ `nourl $i` = "$i" ] && continue
658 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
659 else
660 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
661 fi
662 fi
663 FROM_DISTFILES=0
664 if [ ! -f `nourl $i` ] || [ $ALWAYS_CVSUP = "yes" ]; then
665 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
666 echo "Warning: no URL given for $i"
667 fi
668
669 if [ -n "$(src_md5 "$i")" ] && [ -z "$NODIST" ]; then
a4b50627 670 if good_md5 "$i" && good_size "$i"; then
deccc50e 671 echo "$(nourl "$i") having proper md5sum already exists"
cd445739
AM
672 continue
673 fi
674 target=$(nourl "$i")
675 url=$(distfiles_url "$i")
676 url_attic=$(distfiles_attic_url "$i")
677 FROM_DISTFILES=1
33da77c4 678 if [ "`echo $url | grep -E '^(\.|/)'`" ]; then
2e5be021 679 update_shell_title "get_files: $url"
cd445739
AM
680 ${GETLOCAL} $url $target
681 else
682 if [ -z "$NOMIRRORS" ]; then
683 url="`find_mirror "$url"`"
684 fi
2e5be021 685 update_shell_title "get_files: $url"
ca2e6c31 686 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 687 if [ "`echo $url | grep -E 'ftp://'`" ]; then
2e5be021 688 update_shell_title "get_files: $url"
ca2e6c31 689 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
690 fi
691 fi
692 if ! test -s "$target"; then
693 rm -f "$target"
694 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
2e5be021 695 update_shell_title "get_files: $url_attic"
cd445739
AM
696 ${GETLOCAL} $url_attic $target
697 else
698 if [ -z "$NOMIRRORS" ]; then
699 url_attic="`find_mirror "$url_attic"`"
700 fi
2e5be021 701 update_shell_title "get_files: $url_attic"
ca2e6c31 702 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 703 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
2e5be021 704 update_shell_title "get_files: $url_attic"
ca2e6c31 705 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
706 fi
707 fi
708 fi
947025e5 709 if test -s "$target"; then
710 cvsignore_df $target
711 else
cd445739
AM
712 rm -f "$target"
713 FROM_DISTFILES=0
714 fi
715 elif [ -z "$(src_md5 "$i")" -a "$NOCVS" != "yes" ]; then
716 # ( echo $i | grep -qvE '(ftp|http|https)://' ); -- if CVS should be used, but URLs preferred
717 result=1
718 retries_counter=0
719 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]
720 do
721 retries_counter=$(( $retries_counter + 1 ))
722 output=$(LC_ALL=C cvs $OPTIONS `nourl $i` 2>&1)
723 result=$?
724 [ -n "$output" ] && echo "$output"
725 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
726 echo "Trying again [`nourl $i`]... ($retries_counter)"
727 sleep 2
728 continue
729 else
730 break
731 fi
732 done
733 fi
734
33da77c4 735 if [ -z "$NOURLS" ] && [ ! -f "`nourl $i`" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
736 if [ -z "$NOMIRRORS" ]; then
737 im="`find_mirror "$i"`"
738 else
739 im="$i"
740 fi
2e5be021 741 update_shell_title "get_files: $im"
cd445739 742 ${GETURI} "$im" || \
33da77c4 743 if [ "`echo $im | grep -E 'ftp://'`" ]; then
2e5be021 744 update_shell_title "get_files: $im"
cd445739 745 ${GETURI2} "$im"
7e365483 746 fi
cd445739
AM
747 fi
748
749 fi
750 srcno=$(src_no $i)
751 if [ ! -f "`nourl $i`" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
752 Exit_error err_no_source_in_repo $i;
753 elif [ -n "$UPDATE5" ] && \
754 ( ( [ -n "$ADD5" ] && echo $i | grep -q -E 'ftp://|http://|https://' && \
755 [ -z "$(grep -E -i '^NoSource[ ]*:[ ]*'$i'([ ]|$)' $SPECS_DIR/$SPECFILE)" ] ) || \
756 grep -q -i -E '^#[ ]*source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
757 then
deccc50e 758 echo "Updating source-$srcno md5."
cd445739
AM
759 md5=$(md5sum `nourl $i` | cut -f1 -d' ')
760 perl -i -ne '
deccc50e
AM
761 print unless /^\s*#\s*Source'$srcno'-md5\s*:/i;
762 print "# Source'$srcno'-md5:\t'$md5'\n"
cd445739
AM
763 if /^Source'$srcno'\s*:\s+/;
764 ' \
765 $SPECS_DIR/$SPECFILE
766 fi
2a5f078d 767
a4b50627 768 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
769 :
770 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 771 # wrong md5 from distfiles: remove the file and try again
cd445739 772 # but only once ...
deccc50e 773 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
774 FROM_DISTFILES=2
775 rm -f $target
2e5be021 776 update_shell_title "get_files: $url"
ca2e6c31 777 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 778 if [ "`echo $url | grep -E 'ftp://'`" ]; then
2e5be021 779 update_shell_title "get_files: $url"
ca2e6c31 780 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
781 fi
782 if ! test -s "$target"; then
783 rm -f "$target"
2e5be021 784 update_shell_title "get_files: $url_attic"
ca2e6c31 785 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 786 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
2e5be021 787 update_shell_title "get_files: $url_attic"
ca2e6c31 788 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
789 fi
790 fi
791 test -s "$target" || rm -f "$target"
792 fi
793
a4b50627 794 if good_md5 "$i" && good_size "$i" ; then
cd445739
AM
795 :
796 else
deccc50e
AM
797 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
798 echo "or -5 to update md5 sums, if you're sure files are correct."
cd445739
AM
799 Exit_error err_no_source_in_repo $i
800 fi
801 done
802
803 if [ "$CHMOD" = "yes" ]; then
804 CHMOD_FILES="`nourl $GET_FILES`"
805 if [ -n "$CHMOD_FILES" ]; then
806 chmod $CHMOD_MODE $CHMOD_FILES
807 fi
808 fi
809 unset OPTIONS
810 fi
811}
812
813make_tagver() {
78eab2a1
AM
814
815 if [ -n "$DEBUG" ]; then
816 set -x;
817 set -v;
818 fi
2a5f078d 819
cd445739
AM
820 # Check whether first character of PACKAGE_NAME is legal for tag name
821 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
822 TAG_PREFIX=tag_
823 fi
824 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
825 # Remove #kernel.version_release from TAGVER because tagging sources
826 # could occur with different kernel-headers than kernel-headers used at build time.
827 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
828 echo -n "$TAGVER"
829}
830
831tag_files()
832{
833 TAG_FILES="$@"
834
835 if [ -n "$DEBUG" ]; then
836 set -x;
837 set -v;
838 fi
839
840 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
841 echo "Version: $PACKAGE_VERSION"
842 echo "Release: $PACKAGE_RELEASE"
843
844 TAGVER=`make_tagver`
845
846 if [ "$TAG_VERSION" = "yes" ]; then
847 echo "CVS tag: $TAGVER"
848 fi
849 if [ -n "$TAG" ]; then
850 echo "CVS tag: $TAG"
851 fi
852
853 OPTIONS="tag -F"
854 if [ -n "$CVSROOT" ]; then
855 OPTIONS="-d $CVSROOT $OPTIONS"
856 fi
857
858 cd "$SOURCE_DIR"
859 for i in $TAG_FILES
860 do
861 # don't tag files stored on distfiles
862 [ -n "`src_md5 $i`" ] && continue
863 if [ -f "`nourl $i`" ]; then
864 if [ "$TAG_VERSION" = "yes" ]; then
865 cvs $OPTIONS $TAGVER `nourl $i`
866 fi
867 if [ -n "$TAG" ]; then
868 cvs $OPTIONS $TAG `nourl $i`
869 fi
870 else
871 Exit_error err_no_source_in_repo $i
872 fi
873 done
874
875 cd "$SPECS_DIR"
876 if [ "$TAG_VERSION" = "yes" ]; then
877 cvs $OPTIONS $TAGVER $SPECFILE
878 fi
879 if [ -n "$TAG" ]; then
880 cvs $OPTIONS $TAG $SPECFILE
881 fi
882
883 unset OPTIONS
884 fi
885}
886
887branch_files()
888{
889 TAG=$1
890 echo "CVS branch tag: $TAG"
891 shift;
892
893 TAG_FILES="$@"
894
895 if [ -n "$DEBUG" ]; then
896 set -x;
897 set -v;
898 fi
899
900 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
901
902 OPTIONS="tag -b"
903 if [ -n "$CVSROOT" ]; then
904 OPTIONS="-d $CVSROOT $OPTIONS"
905 fi
906 cd "$SOURCE_DIR"
907 for i in $TAG_FILES
908 do
909 if [ -f `nourl $i` ]; then
910 cvs $OPTIONS $TAG `nourl $i`
911 else
912 Exit_error err_no_source_in_repo $i
913 fi
914 done
915 cd "$SPECS_DIR"
916 cvs $OPTIONS $TAG $SPECFILE
917
918 unset OPTIONS
919 fi
920}
921
922
923
59398507 924build_package()
925{
2e5be021 926 update_shell_title "build_package"
cd445739
AM
927 if [ -n "$DEBUG" ]; then
928 set -x;
929 set -v;
930 fi
5a491465 931
cd445739
AM
932 cd "$SPECS_DIR"
933
934 if [ -n "$TRY_UPGRADE" ]; then
2e5be021 935 update_shell_title "build_package: try_upgrade"
cd445739 936 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 937 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 938 else
cc538c24 939 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
940 fi
941
942 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
943
944 if [ -n "$TNEWVER" ]; then
945 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
946 echo "New version found, updating spec file to version " $TNEWVER
947 cp -f $SPECFILE $SPECFILE.bak
948 chmod +w $SPECFILE
949 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 950 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
cd445739 951 parse_spec;
7f347798 952 if [ -n "$ICONS" ]; then
953 get_files $ICONS;
954 parse_spec;
955 fi
f7b91886 956 NODIST="yes" UPDATE5="yes" get_files "$SOURCES $PATCHES";
cd445739
AM
957 unset TOLDVER TNEWVER TNOTIFY
958 fi
959 fi
960 cd "$SPECS_DIR"
2a5f078d 961
cd445739
AM
962 case "$COMMAND" in
963 build )
964 BUILD_SWITCH="-ba" ;;
965 build-binary )
966 BUILD_SWITCH="-bb" ;;
967 build-source )
968 BUILD_SWITCH="-bs --nodeps" ;;
969 build-prep )
970 BUILD_SWITCH="-bp --nodeps" ;;
971 esac
c890b916 972
2e5be021 973 update_shell_title "build_package: $COMMAND"
cd445739
AM
974 if [ -n "$LOGFILE" ]; then
975 LOG=`eval echo $LOGFILE`
976 if [ -d "$LOG" ]; then
977 echo "Log file $LOG is a directory."
978 echo "Parse error in the spec?"
979 Exit_error err_build_fail;
980 fi
981 if [ -n "$LASTLOG_FILE" ]; then
982 echo "LASTLOG=$LOG" > $LASTLOG_FILE
983 fi
984 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
21bc1a97 985 (time eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
986 RETVAL=`cat $RES_FILE`
987 rm $RES_FILE
988 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
989 if [ "$RETVAL" -eq "0" ]; then
990 mv $LOG $LOGDIROK
991 else
992 mv $LOG $LOGDIRFAIL
993 fi
994 fi
8ba5cdda 995 else
8f96ab6c 996 eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 997 RETVAL=$?
8ba5cdda 998 fi
cd445739
AM
999 if [ "$RETVAL" -ne "0" ]; then
1000 if [ -n "$TRY_UPGRADE" ]; then
1001 echo "\n!!! Package with new version cannot be build automagically\n"
1002 mv -f $SPECFILE.bak $SPECFILE
1003 fi
1004 Exit_error err_build_fail;
1005 fi
1006 unset BUILD_SWITCH
1007}
1008
1009nourl()
1010{
1011 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1012}
1013
cd445739
AM
1014install_required_packages()
1015{
1016 run_poldek -vi $1
1017 return $?
1018}
1019
1020set_bconds_values()
1021{
2e5be021 1022 update_shell_title "set_bconds_values"
c890b916 1023
cd445739
AM
1024 AVAIL_BCONDS_WITHOUT=""
1025 AVAIL_BCONDS_WITH=""
1026 if `grep -q ^%bcond ${SPECFILE}`; then
1027 BCOND_VERSION="NEW"
36d03934 1028 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
cd445739
AM
1029 BCOND_VERSION="OLD"
1030 else
1031 BCOND_VERSION="NONE"
1032 fi
301cbfd4
ER
1033
1034 # expand bconds from ~/.bcondrc
1035 # The file structure is like gentoo's package.use:
1036 # ---
1037 # * -selinux
1038 # samba -mysql -pgsql
47a8df12 1039 # w32codec-installer license_agreement
301cbfd4
ER
1040 # php +mysqli
1041 # ---
c8a3e2ac 1042 if [ "${BCOND_VERSION}" != "NONE" ] && ( [ -f $HOME/.bcondrc ] || ( [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] ) ) ; then
301cbfd4
ER
1043 # This takes package name, first defined in spec.
1044 # so consider that when defining flags for package.
1045 PN=`$RPM -q --qf '%{NAME}\n' --specfile $SPECFILE | head -n 1`
3e1cbfe0 1046 SN=${SPECFILE%%\.spec}
301cbfd4
ER
1047 AVAIL=`$RPMBUILD --bcond $SPECFILE`
1048
c8a3e2ac
AG
1049 BCONDRC=$HOME/.bcondrc
1050 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && BCONDRC=$HOME_ETC/.bcondrc
1051
301cbfd4
ER
1052 while read pkg flags; do
1053 # ignore comments
1054 [[ "$pkg" == \#* ]] && continue
1055
1056 # any package or current package?
3e1cbfe0 1057 if [ "$pkg" = "*" ] || [ "$pkg" = "$PN" ] || [ "$pkg" = "$SN" ]; then
301cbfd4
ER
1058 for flag in $flags; do
1059 opt=${flag#[+-]}
1060
1061 # use only flags which are in this package.
1062 if [[ $AVAIL = *${opt}* ]]; then
3b5101f0
ER
1063 if [[ $flag = -* ]]; then
1064 BCOND="$BCOND --without $opt"
301cbfd4 1065 else
3b5101f0 1066 BCOND="$BCOND --with $opt"
301cbfd4
ER
1067 fi
1068 fi
1069 done
1070 fi
c8a3e2ac 1071 done < $BCONDRC
301cbfd4
ER
1072 fi
1073
cd445739
AM
1074 case "${BCOND_VERSION}" in
1075 NONE)
7e365483 1076 :
cd445739 1077 ;;
7e365483 1078 OLD)
cd445739
AM
1079 echo "Warning: This spec has old style bconds. Fix it || die."
1080 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_without_`
1081 do
1082 AVAIL_BCOND_WITHOUT=`echo $opt|sed -e "s/^_without_//g"`
1083 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1084 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1085 else
1086 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1087 fi
1088 done
2a5f078d 1089
cd445739
AM
1090 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_with_`
1091 do
1092 AVAIL_BCOND_WITH=`echo $opt|sed -e "s/^_with_//g"`
1093 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1094 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1095 else
1096 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1097 fi
1098 done
1099 ;;
1100 NEW)
1101 cond_type="" # with || without
1102 for opt in `$RPMBUILD --bcond $SPECFILE`
1103 do
1104 case "$opt" in
1105 _without)
1106 cond_type="without"
1107 ;;
1108 _with)
1109 cond_type="with"
1110 ;;
f8d24cee 1111 _without_*)
1112 AVAIL_BCOND_WITHOUT="`echo $opt | sed 's/^_without_//g'`"
1113 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1114 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1115 else
1116 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1117 fi
1118 ;;
1119 _with_*)
1120 AVAIL_BCOND_WITH="`echo $opt | sed 's/^_with_//g'`"
1121 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1122 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1123 else
1124 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1125 fi
1126 ;;
cd445739
AM
1127 *)
1128 case "$cond_type" in
1129 with)
1130 cond_type=''
1131 AVAIL_BCOND_WITH="$opt"
1132 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1133 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1134 else
1135 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1136 fi
7e365483 1137 ;;
cd445739
AM
1138 without)
1139 cond_type=''
1140 AVAIL_BCOND_WITHOUT="$opt"
1141 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1142 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1143 else
1144 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1145 fi
1146 ;;
1147 esac
1148 ;;
1149 esac
1150 done
1151 ;;
1152 esac
1153}
1154
1155run_sub_builder()
1156{
1157 package_name="${1}"
1158 echo -ne "Package installation failed:\t$package_name\n"
1159 #
1160